﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;
using System.Reflection;
using System.IO;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.AppStyling;

namespace MemDataTable_CS
{
    public partial class Form1 : Form
    {
        private DataTable dt1;

        public Form1()
        {
            InitializeComponent();

            this.ultraGrid1.BeforeColumnChooserDisplayed += this.UltraGrid1_BeforeColumnChooserDisplayed;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Set grid's DataSource
            dt1 = DummyDataCreator.GetData(100);

            dt1.TableName = "Band 0";

            foreach (DataRow row in dt1.Rows)
            {
            }

            dt1.AcceptChanges();
            this.ultraGrid1.DataSource = dt1;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];
            var ov = layout.Override;

            ov.RowSelectors = DefaultableBoolean.True;
            ov.RowSelectorHeaderStyle = RowSelectorHeaderStyle.ColumnChooserButton;
        }

        private void UltraGrid1_BeforeColumnChooserDisplayed(object sender, BeforeColumnChooserDisplayedEventArgs e)
        {
            var screen = Infragistics.Win.Utilities.ScreenFromRectangle(this.Bounds);
            if (!screen.Bounds.Contains(e.Dialog.Bounds))
            {
                e.Dialog.VisibleChanged += Dialog_VisibleChanged;
            }
        }

        private void Dialog_VisibleChanged(object sender, EventArgs e)
        {
            var dialog = (Form)sender;
            dialog.VisibleChanged -= Dialog_VisibleChanged;

            if (!dialog.Visible)
                return;

            var screen = Infragistics.Win.Utilities.ScreenFromRectangle(this.Bounds);
            dialog.DesktopBounds = new Rectangle(
                 screen.Bounds.X,
                 screen.Bounds.Y,
                 dialog.Bounds.Width,
                 dialog.Bounds.Height
                 );
        }
    }
}

